<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.axiom.om.OMFactory" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.OMAbstractFactory" %>
<%@ page import="java.io.PrintWriter" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.wso2.carbon.bpel.ui.BPELPackageManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.DeployedPackagesPaginated" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.Package_type0" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.ProcessesInPackage" %>
<%
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    Log log = LogFactory.getLog("deploy.packagesOnPages.ajaxprocessor");
    Integer pageNumber = (Integer) session.getAttribute("pkgpageNumber");
    if (pageNumber == null || pageNumber < 0) {
        pageNumber = 0;
    }

    BPELPackageManagementServiceClient client;
    DeployedPackagesPaginated deployedPackages;
    ProcessesInPackage processes;
    OMFactory factory = OMAbstractFactory.getOMFactory();
    OMElement root = factory.createOMElement("PackagesOnPage", null);
    String operation = request.getParameter("operation");

    if (operation != null && operation.toLowerCase().equals("packages")) {
        try {
            client = new BPELPackageManagementServiceClient(cookie, backendServerURL, configContext);
        } catch (Exception e) {
            log.error("BPEL Package Management Service Client Creation Failed.", e);
            return;
        }

        while (pageNumber >= 0)  {
            try {
                deployedPackages = client.listDeployedPackagesPaginated(pageNumber);
            } catch (Exception e) {
                log.error("listDeployedPackagesPaginated Operation Failed.", e);
                return;
            }

            if (deployedPackages != null && deployedPackages.get_package() != null &&
                    deployedPackages.get_package().length > 0 && deployedPackages.get_package()[0] != null) {
                for (Package_type0 deployedPackage : deployedPackages.get_package()) {
                    String processList = "";
                    OMElement bpelPackage = factory.createOMElement("Package", null, root);
                    processes = client.listProcessesInPackage(deployedPackage.getName());
                    OMElement name = factory.createOMElement("Name", null, bpelPackage);
                    name.setText(deployedPackage.getName());
                    String[] processesArray = processes.getProcess();
                    if(processesArray != null && processesArray.length > 0 ){
                        for (String processName : processesArray) {

                            processList += "<a href='process_view.jsp?pid="+processName +"'>"+processName+ "</a>, ";
                        }
                    } else {
                        processList = " , ";
                    }

                    processList = processList.substring(0, processList.length() - 2);
                    OMElement processesEle = factory.createOMElement("Processes", null, bpelPackage);
                    processesEle.setText(processList);
                    OMElement packageStatusEle = factory.createOMElement("Status", null, bpelPackage);
                    packageStatusEle.setText(deployedPackage.getState().getValue());

                }
                OMElement numPagesEle = factory.createOMElement("Pages", null, root);
                numPagesEle.setText(Integer.toString(deployedPackages.getPages()));
                OMElement pageNumEle = factory.createOMElement("PageNumber", null, root);
                pageNumEle.setText(Integer.toString(pageNumber)); 
                break;
            } else {
                pageNumber--;
                session.setAttribute("pkgpageNumber", pageNumber);
            }
        }

        if (pageNumber < 0) {
            OMElement numPagesEle = factory.createOMElement("Pages", null, root);
            numPagesEle.setText("0");
        }

    } else {
        return;
    }
    request.setCharacterEncoding("UTF-8");
    // Set content to xml
    response.setContentType("text/xml; charset=UTF-8");
    // Set standard HTTP/1.1 no-cache headers.
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    PrintWriter pw = response.getWriter();
    pw.write(root.toString());
    pw.flush();


%>
