<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.lang.String" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.wso2.carbon.bpel.ui.prettyxml.PrettyXML" %>
<%@ page import="java.io.StringReader" %>
<%@ page import="java.io.StringWriter" %>
<%@ page import="org.wso2.carbon.bpel.ui.InstanceManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.*" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.wso2.carbon.utils.xml.XMLPrettyPrinter" %>
<%@ page import="java.io.ByteArrayInputStream" %>
<%@ page import="org.wso2.carbon.bpel.ui.ScopeActivityHelper" %>
<%@ page import="java.util.List" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.apache.http.HttpStatus" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<fmt:bundle basename="org.wso2.carbon.bpel.ui.i18n.Resources">
<%
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");
    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");
    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    String iid = request.getParameter("iid");

    Log log = LogFactory.getLog("instance.info.ajaxprocessor");

    InstanceManagementServiceClient client;
    InstanceInfoType instance;
    ScopeInfoType rootScopeInfo;

    try {
        client = new InstanceManagementServiceClient(cookie, backendServerURL, configContext);
    } catch (Exception e) {
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        log.error("Instance Management Client Creation Failed.", e);
        return;
    }

    try {
        instance = client.getInstanceInfo(Long.parseLong(iid));     /* do we need this back end call?*/
    } catch (Exception e) {
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        log.error("getInstanceInfo Operation Failed. ", e);
        return;
    }
    if (instance == null) {
        return;
    }
    ScopeActivityHelper scopeActivityHelper;
    try {
        scopeActivityHelper = new ScopeActivityHelper(cookie, backendServerURL, configContext,
                Long.parseLong(instance.getRootScope().getSiid()));
    } catch (Exception e) {
        log.error("ScopeActivityHelper Creation Failed. ", e);
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        return;
    }

    try {
        rootScopeInfo = scopeActivityHelper.getRootScope();
    } catch (Exception e) {
        log.error("ScopeActivityHelper getRootscope Failed. ", e);
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        return;
    }
    
    if (client != null && rootScopeInfo != null && instance != null) {
%>
<script type="text/javascript">
    function showVariableValue(hiddenFieldID) {
        var hID = '#' + hiddenFieldID;
        var parent = hID + 'Parent';
        var content = jQuery(parent).html();
        jQuery(hID).dialog({
            width:450,
            height:160,
            minHeight:160,
            minWidth:330,
            modal:true,
            open: function(event, ui) {
                jQuery(hID).css("display", "block");
            },
            close:function() {
                jQuery(this).dialog('destroy').remove();
                jQuery(parent).html(content);
                return false;
            }
        });
        return false;
    }
</script>
<table width="100%">
<strong style="padding-bottom:5px;margin-bottom:5px;margin-top:10px;"><fmt:message key="instance.information"/></strong>
<tr>

<td>

    <table class="styledLeft" id="instanceStatic">
        <thead>
        <tr>
            <th colspan="2"><fmt:message key="instance.details"/></th>
        </tr>
        </thead>
        <tbody>
        <tr>
            <td><fmt:message key="instance.id"/></td>
            <td><%=instance.getIid()%>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="process.id"/></td>
            <td>
                <a href="process_view.jsp?pid=<%=instance.getPid()%>"><%=instance.getPid()%>
                </a>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="status"/></td>
            <td><%=instance.getStatus()%>
                <%
                    if (instance.getStatus().getValue().toUpperCase().equals("ACTIVE")) {
                %>
                [&nbsp;
                <a href='#' onclick="BPEL.instance.suspendIns(<%=instance.getIid()%>);"><fmt:message key="suspend"/></a>
                &nbsp;]
                &nbsp;
                [&nbsp;
                <a href='#' onclick="BPEL.instance.terminateIns(<%=instance.getIid()%>);"><fmt:message
                        key="terminate"/></a>
                &nbsp;]
                &nbsp;
                [&nbsp;
                <a href='#' onclick="BPEL.instance.deleteIns(<%=instance.getIid()%>);"><fmt:message key="delete"/></a>
                &nbsp;]
                <%
                } else if (instance.getStatus().getValue().toUpperCase().equals("COMPLETED") ||
                        instance.getStatus().getValue().toUpperCase().equals("ERROR") ||
                        instance.getStatus().getValue().toUpperCase().equals("FAILED")) {
                %>
                &nbsp;
                [&nbsp;
                <a href='#' onclick="BPEL.instance.deleteIns(<%=instance.getIid()%>);"><fmt:message key="delete"/></a>
                &nbsp;]
                <%
                } else if (instance.getStatus().getValue().toUpperCase().equals("TERMINATED")) {
                %>
                &nbsp;
                [&nbsp;
                <a href='#' onclick="BPEL.instance.deleteIns(<%=instance.getIid()%>);"><fmt:message key="delete"/></a>
                &nbsp;]
                <%
                } else if (instance.getStatus().getValue().toUpperCase().equals("SUSPENDED")) {
                %>
                [&nbsp;
                <a href='#' onclick="BPEL.instance.resumeIns(<%=instance.getIid()%>);"><fmt:message key="resume"/></a>
                &nbsp;]
                &nbsp;
                [&nbsp;
                <a href='#' onclick="BPEL.instance.terminateIns(<%=instance.getIid()%>);"><fmt:message
                        key="terminate"/></a>
                &nbsp;]
                &nbsp;
                [&nbsp;
                <a href='#' onclick="BPEL.instance.deleteIns(<%=instance.getIid()%>);"><fmt:message key="delete"/></a>
                &nbsp;]
                <%
                    }
                %>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="date.started"/></td>
            <td><%=instance.getDateStarted().getTime().toString()%>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="last.active.date"/></td>
            <td><%=instance.getDateLastActive().getTime().toString()%>
            </td>
        </tr>
        <%
            if (rootScopeInfo.getCorrelationSets() != null &&
                    rootScopeInfo.getCorrelationSets().getCorrelationSet() != null &&
                    rootScopeInfo.getCorrelationSets().getCorrelationSet().length > 0 &&
                    rootScopeInfo.getCorrelationSets().getCorrelationSet()[0] != null) {
        %>
        <tr>
            <td colspan="2"><strong><fmt:message
                    key="correlation.properties"/> <%=rootScopeInfo.getCorrelationSets().getCorrelationSet().length%>
            </strong></td>
        </tr>
        <%
            for (CorrelationSet_type0 coSet : rootScopeInfo.getCorrelationSets().getCorrelationSet()) {
                if (coSet.getCorrelationProperty() != null) {
                    for (CorrelationPropertyType coProp : coSet.getCorrelationProperty()) {
                        String propName = coProp.getPropertyName().toString();
                        String propVal = coProp.getString();
        %>
        <tr>
            <td><%=propName%>
            </td>
            <td><%=propVal%>
            </td>
        </tr>
        <%
                        }
                    }
                }

            }
        %>
        <tr>
            <td colspan="2"><strong><fmt:message key="event.information"/></strong></td>
        </tr>
        <%
            if (instance.getEventInfo() != null && instance.getEventInfo().getCount() > 0) {
        %>
        <tr>
            <td><fmt:message key="count"/></td>
            <td><%=instance.getEventInfo().getCount()%>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="first.event"/></td>
            <td><%=instance.getEventInfo().getFirstDateTime().getTime().toString()%>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="last.event"/></td>
            <td><%=instance.getEventInfo().getLastDateTime().getTime().toString()%>
            </td>
        </tr>
        <%
        } else {
        %>
        <tr>
            <td><fmt:message key="event.disable"/></td>
        </tr>
        <%
            }
            if (instance.getDateErrorSince() != null) {
        %>
        <tr>
            <td><fmt:message key="error.since"/></td>
            <td><%=instance.getDateErrorSince().getTime().toString()%>
            </td>
        </tr>
        <%
            }
        %>
            <%--<%--%>
            <%--if (iInfoWithActivities.getFailures() != null) {--%>
            <%--%>--%>
            <%--<tr>--%>
            <%--<td colspan="2">TODO: Failures</td>--%>
            <%--</tr>--%>
            <%--<%--%>
            <%--}--%>
            <%--%>--%>

            <%--<%--%>
            <%--if (iInfoWithActivities.getFaultInfo() != null) {--%>
            <%--%>--%>
            <%--<tr>--%>
            <%--<td colspan="2">TODO: Fault Info</td>--%>
            <%--</tr>--%>
            <%--<%--%>
            <%--}--%>
            <%--%>--%>
        </tbody>
    </table>


</td>
<td>
    <table class="styledLeft" id="tableRootScope">
        <thead>
        <tr>
            <th colspan="2"><fmt:message key="root.scope.information"/></th>
        </tr>
        </thead>
        <tbody>
        <tr>
            <td><fmt:message key="scope.id"/></td>
            <td><%=instance.getRootScope().getSiid()%>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="scope.name"/></td>
            <td><%=instance.getRootScope().getName()%>
            </td>
        </tr>
        <tr>
            <td><fmt:message key="status"/></td>
            <td><%=instance.getRootScope().getStatus().getValue()%>
            </td>
        </tr>
        <%
            Variables_type0 vars = rootScopeInfo.getVariables();
            if (vars.getVariableRef() != null && vars.getVariableRef().length > 0) {
        %>
        <tr>
            <td colspan="2"><strong><fmt:message key="variables"/></strong></td>
        </tr>
        <%
            PrettyXML.init();
            for (VariableRefType varRef : vars.getVariableRef()) {
        %>
        <tr>
            <td><%=varRef.getName()%>
            </td>
            <%
                VariableInfoType varInfo;
                try {
                    varInfo = client.getVariableInfo(varRef.getSiid(), varRef.getName());
                } catch (Exception e) {
                    response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
                    CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
                    log.error("getVariableInfo Operation Failed. ", e);
                    return;
                }
                String varStr = "<div class='xmlverb-default'>Nil</div>";
                if (varInfo != null && varInfo.getValue() != null && varInfo.getValue().getExtraElement() != null
                        && varInfo.getValue().getExtraElement()[0] != null) {
                    String id = varRef.getName() + "_HiddenField";
                    String varValue = null;
                    for (OMElement omEle : varInfo.getValue().getExtraElement()) {
                        if (varValue == null) {
                            varValue = omEle.toString();
                        } else {
                            varValue += omEle.toString();
                        }
                    }
                    boolean isEmpty = false;
                    if (varValue == null || varValue.length() == 0 || varValue.equals("Nil")) {
                        varStr = "<div class='xmlverb-default'>Nil</div>";
                        isEmpty = true;
                    } else if (varValue.equals("<empty-value>Nil</empty-value>")) {
                        isEmpty = true;
                    } else {
                        XMLPrettyPrinter xmlPP = new XMLPrettyPrinter(new ByteArrayInputStream(varValue.getBytes()));
                        String ppedStr = xmlPP.xmlFormat();
                        StringReader sr = new StringReader(ppedStr);
                        StringWriter sw = new StringWriter();
                        PrettyXML.writeFancily(sr, sw);
                        sr.close();
                        varStr = sw.toString();
                    }
            %>
            <td>
                <%
                    if (isEmpty) {
                %>
                <div>empty value</div>
                <%
                } else {
                %>
                <div id='dialog<%=id%>Parent'>
                    <div id='dialog<%=id%>' title='Value of <%=varRef.getName()%>' style="display: none;"><%=varStr%>
                    </div>
                </div>

                <script type="text/javascript">
                    jQuery(".xmlverb-default").css("border", "0px none");
                </script>
                <a href="#" class="icon-link" style="background-image:url(images/view.gif);"
                   onclick="showVariableValue('dialog<%=id%>')">View Value</a>
                <%
                    }
                %>
            </td>
            <%

            } else {
            %>
            <td><fmt:message key="error.occurres.while.getting.the.value"/></td>
            <%
                }
            %>
        </tr>
        <%
                }
            }
            List<ScopeRefType> childScopes = null;
            try {
                childScopes = scopeActivityHelper.getChildScopes();
            } catch (Exception e) {
                response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
                CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
                return;
            }
            if (!childScopes.isEmpty()) {
        %>
        <tr>
            <td colspan="2"><strong><fmt:message key="child.scopes"/></strong></td>
        </tr>
        <%
            for (ScopeRefType s : childScopes) {
        %>

        <tr>
            <td><%=s.getSiid()%>
            </td>
            <td><%=s.getName()%>
            </td>
        </tr>
        <%
                }
            }
        %>

        </tbody>
    </table>

</td>
</tr>
<%
    int activityCount;
    try {
        activityCount = scopeActivityHelper.getActivityCount();
    } catch (Exception e) {
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        return;
    }
    if (activityCount > 0) {
%>
<tr>
    <td colspan="2">
        <strong style="padding-bottom:5px;margin-bottom:5px;margin-top:10px;"><fmt:message
                key="activity.information"/></strong>
        <table class="styledLeft" id="tableActivityInfo">
            <thead>
            <tr>
                <th><fmt:message key="id"/></th>
                <th><fmt:message key="name1"/></th>
                <th><fmt:message key="scope.id"/></th>
                <th><fmt:message key="type"/></th>
                <th><fmt:message key="status"/></th>
                <th><fmt:message key="date.enabled"/></th>
                <th><fmt:message key="date.started"/></th>
                <th><fmt:message key="date.completed"/></th>
                <%
                    if (scopeActivityHelper.isHasFailed()) {
                %>
                <th><fmt:message key="recovery.actions"/></th>
                <%
                    }
                %>
            </tr>
            </thead>
            <tbody>
            <%
                List<ActivityInfoType> activities_type = scopeActivityHelper.getActivityInfo();
                        if (activities_type != null) {
                            for (ActivityInfoType acInfo : activities_type) {
            %>
            <tr>
                <td><%=acInfo.getAiid()%>
                </td>
                <td><%=acInfo.getName()%>
                </td>
                <td>
                    <%=acInfo.getScope().getSiid()%>
                </td>
                <td><%=acInfo.getType()%>
                </td>
                <td><%=acInfo.getStatus().getValue()%>
                </td>
                <%
                    if (acInfo.getDateEnabled() != null) {
                %>
                <td><%=acInfo.getDateEnabled().getTime().toString()%>
                </td>
                <%
                } else {
                %>
                <td></td>
                <%
                    }
                %>
                <%
                    if (acInfo.getDateStarted() != null) {
                %>
                <td><%=acInfo.getDateStarted().getTime().toString()%>
                </td>
                <%
                } else {
                %>
                <td></td>
                <%
                    }
                %>
                <%
                    if (acInfo.getDateCompleted() != null) {
                %>
                <td><%=acInfo.getDateCompleted().getTime().toString()%>
                </td>
                <%
                } else {
                %>
                <td></td>
                <%
                    }
                    if (scopeActivityHelper.isHasFailed()) {
                        if (acInfo.getStatus().getValue().equals("FAILURE")) {
                             if (instance.getStatus().getValue().toUpperCase().equals("ACTIVE")){
                %>
                <td>
                    [&nbsp;
                    <a href='#'
                       onclick="BPEL.instance.recover(<%=instance.getIid()%>, <%=acInfo.getAiid()%>, 'retry');"><fmt:message
                            key="retry"/></a>
                    &nbsp;]
                    &nbsp;
                    [&nbsp;
                    <a href='#'
                       onclick="BPEL.instance.recover(<%=instance.getIid()%>, <%=acInfo.getAiid()%>, 'cancel');"><fmt:message
                            key="cancel"/></a>
                    &nbsp;]
                </td>
                <%
                        } else if (instance.getStatus().getValue().toUpperCase().equals("SUSPENDED")) {
                %>
                <td>
                    [&nbsp;
                    <a href='#'
                       onclick="BPEL.instance.recover(<%=instance.getIid()%>, <%=acInfo.getAiid()%>, 'suspended');"><fmt:message
                            key="retry"/></a>
                    &nbsp;]
                </td>
                <%
                        } else {
                %>
                <td></td>
                <%
                        }
                    } else {
                %>
                <td></td>
                <%
                    }
                %>

            </tr>
            <%
                        }
                    }
                }
            %>
            </tbody>
            <tfoot>
            </tfoot>
        </table>
    </td>
</tr>
<%
    }
%>
</table>
<%
} else {
%>
<p>Error occured while getting the summary from back end server.</p>
<%

    }
%>
</fmt:bundle>

