<%@ page import="org.apache.axiom.om.OMAbstractFactory" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.OMFactory" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.io.PrintWriter" %>

<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.InstanceSummary" %>
<%@ page import="org.wso2.carbon.bpel.ui.ProcessManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.Instances_type0" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.ProcessInfoType" %>

<%
    response.setHeader("Cache-Control",
                "no-store, max-age=0, no-cache, must-revalidate");
        // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");
        // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");
    InstanceSummary instanceSummary;
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    Log log = LogFactory.getLog("instance.summary.ajaxprocessor");

    String pid = request.getParameter("pid");

    ProcessManagementServiceClient client;
    ProcessInfoType processInfo;

    try {
        client = new ProcessManagementServiceClient(cookie, backendServerURL, configContext);
    } catch (Exception e) {
        log.error("Process Management Service Client Failed.", e);
        return;
    }

    processInfo = client.getProcessInfo(pid);
    
    OMFactory factory = OMAbstractFactory.getOMFactory();
    OMElement root = factory.createOMElement("InstanceSummary", null);

    if (processInfo != null) {
        instanceSummary = processInfo.getInstanceSummary();
        
        Instances_type0[] processInstances = instanceSummary.getInstances();       // To add new ProcessManagementServiceClient
        int activeInstances = 0;
        int completedInstances = 0;
        int failedInstances = 0;
        int errorInstances = 0;
        int suspendedInstances = 0;
        int terminatedInstances = 0;
        int totalInstances = 0;
        for (Instances_type0 processInstance : processInstances) {
            String state = processInstance.getState().getValue();
            if (state.equals("ACTIVE")) {
                activeInstances = processInstance.getCount();
            }
            else if (state.equals("COMPLETED")) {
                completedInstances = processInstance.getCount();
            }
            else if (state.equals("TERMINATED")) {
                terminatedInstances = processInstance.getCount();
            }
            else if (state.equals("FAILED")) {
                failedInstances = processInstance.getCount();
            }
            else if (state.equals("SUSPENDED")) {
                suspendedInstances = processInstance.getCount();
            }
            else if (state.equals("ERROR")) {
                errorInstances = processInstance.getCount();
            }
            else {
                log.error("Invalid State");
            }
            totalInstances += processInstance.getCount();
        }

        OMElement activeEle = factory.createOMElement("Active", null, root);
        activeEle.setText(Integer.toString(activeInstances));
        OMElement completedEle = factory.createOMElement("Completed", null, root);
        completedEle.setText(Integer.toString(completedInstances));
        OMElement failedEle = factory.createOMElement("Failed", null, root);
        failedEle.setText(Integer.toString(failedInstances));
        OMElement errorEle = factory.createOMElement("Error", null, root);
        errorEle.setText(Integer.toString(errorInstances));
        OMElement suspendedEle = factory.createOMElement("Suspended", null, root);
        suspendedEle.setText(Integer.toString(suspendedInstances));
        OMElement terminatedEle = factory.createOMElement("Terminated", null, root);
        terminatedEle.setText(Integer.toString(terminatedInstances));
        OMElement totalEle = factory.createOMElement("Total", null, root);
        totalEle.setText(Integer.toString(totalInstances));

    }


    request.setCharacterEncoding("UTF-8");
    // Set content to xml
    response.setContentType("text/xml; charset=UTF-8");
    // Set standard HTTP/1.1 no-cache headers.
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    PrintWriter pw = response.getWriter();
    pw.write(root.toString());
    pw.flush();
%>

