<%@ page import="org.apache.axiom.om.OMAbstractFactory" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.OMFactory" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.io.PrintWriter" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.ProcessInfoType" %>
<%@ page import="org.wso2.carbon.bpel.ui.ProcessManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.ProcessInfoListPaginated" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.Instances_type0" %>
<%@ page import="java.util.ArrayList" %>


<%
    response.setHeader("Cache-Control", "no-store, max-age=0, no-cache, must-revalidate");
        // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");
        // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    ProcessInfoListPaginated processList;
    int numberOfPages;
    ProcessInfoType[] processes;
    
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    Log log = LogFactory.getLog("list.processes.ajaxprocessor");
    String filter = (String) session.getAttribute("pfilter");
    String orderBy = (String) session.getAttribute("porder");

    Integer pageNumber = (Integer) session.getAttribute("ppageNumber");
    if (pageNumber == null) {
        pageNumber = 0;
    }

    OMFactory factory = OMAbstractFactory.getOMFactory();
    OMElement root = factory.createOMElement("ProcessList", null);
    
    ProcessManagementServiceClient client;

    try {
        client = new ProcessManagementServiceClient(cookie, backendServerURL, configContext);
    } catch (Exception e) {
        log.error("Process Management Client Creation Failed.", e);
        return;
    }

    while (pageNumber >= 0) {
        if (client != null) {
            try {
                processList = client.listProcessesPaginated(filter, orderBy, pageNumber);
            } catch (Exception e) {
                log.error("listProcessesPaginated Operation Failed.", e);
                return;
            }
        }
        else {
            log.error("Error creating the client");
            return;
        }

        if (processList == null) {
            log.error("Error occurred while fetching process list. Make sure process filter values are set correctly");
            numberOfPages = 0;
        } else {
            numberOfPages = processList.getPages();
        }
        
        if (numberOfPages != 0) {
            processes = processList.getProcessInfo();
            if (processes != null) {
                for (ProcessInfoType process : processes) {
                    OMElement processEle = factory.createOMElement("Process", null);
                    OMElement pidEle = factory.createOMElement("Pid", null, processEle);
                    pidEle.setText(process.getPid());
                    OMElement nameEle = factory.createOMElement("Name", null, processEle);
                    nameEle.setText(process.getPid());
                    OMElement statusEle = factory.createOMElement("Status", null, processEle);
                    statusEle.setText(process.getStatus().getValue());
                    OMElement olderVersionEle = factory.createOMElement("OlderVersion", null, processEle);
                    olderVersionEle.setText(Integer.toString(process.getOlderVersion()));
                    OMElement versionEle = factory.createOMElement("Version", null, processEle);
                    versionEle.setText(Long.toString(process.getVersion()));
                    OMElement packageNameEle = factory.createOMElement("Package", null, processEle);
                    packageNameEle.setText(process.getDeploymentInfo().getPackageName());
                    OMElement depDate = factory.createOMElement("Deployed", null, processEle);
                    depDate.setText(process.getDeploymentInfo().getDeployDate().getTime().toString());


                    OMElement addresses = factory.createOMElement("EndPointAddresses", null, processEle);
                    if (process.getStatus().getValue().equals("ACTIVE")) {
                        String[] endPointAddresses;
                        ArrayList<String> httpEndPointAddress = new ArrayList<String>();

                        try {
                            endPointAddresses = client.getServiceLocationForProcess(process.getPid());
                            if (endPointAddresses == null) {
                                log.error("No end point addresses found for Try-It.");
                                return;
                            }
                        } catch (Exception e) {
                            log.error("getServiceLocationForProcess Operation Failed.", e);
                            return;
                        }

                        for (String endPointAddress : endPointAddresses) {
                            if (endPointAddress.startsWith("http://")) {
                                if (endPointAddress.charAt(endPointAddress.length() - 1) == '/') {
                                    httpEndPointAddress.add(endPointAddress.substring(0, endPointAddress.length() - 1));
                                }
                                else {
                                    httpEndPointAddress.add(endPointAddress);
                                }
                            }
                        }

                        if (httpEndPointAddress.isEmpty()) { //for username token
                            for (String endPointAddress : endPointAddresses) {
                                if (endPointAddress.startsWith("https://")) {
                                    if (endPointAddress.charAt(endPointAddress.length() - 1) == '/') {
                                        httpEndPointAddress.add(endPointAddress.substring(0, endPointAddress.length() - 1));
                                    }
                                    else {
                                        httpEndPointAddress.add(endPointAddress);
                                    }
                                }
                            }
                        }

                        if (httpEndPointAddress != null && !httpEndPointAddress.isEmpty()) {
                            for (String httpEPA : httpEndPointAddress) {
                                OMElement address = factory.createOMElement("EndPointAddress", null, addresses);
                                address.setText(httpEPA);
                            }
                        }
                    }

                    OMElement instanceSummaryEle = factory.createOMElement("InstanceSummary", null, processEle);

                    Instances_type0[] processInstances = process.getInstanceSummary().getInstances();
                    int activeInstances = 0;
                    int completedInstances = 0;
                    int failedInstances = 0;
                    int errorInstances = 0;
                    int suspendedInstances = 0;
                    int terminatedInstances = 0;
                    for (Instances_type0 processInstance : processInstances) {
                        String state = processInstance.getState().getValue();
                        if (state.equals("ACTIVE")) {
                            activeInstances = processInstance.getCount();
                        }
                        else if (state.equals("COMPLETED")) {
                            completedInstances = processInstance.getCount();
                        }
                        else if (state.equals("TERMINATED")) {
                            terminatedInstances = processInstance.getCount();
                        }
                        else if (state.equals("FAILED")) {
                            failedInstances = processInstance.getCount();
                        }
                        else if (state.equals("SUSPENDED")) {
                            suspendedInstances = processInstance.getCount();
                        }
                        else if (state.equals("ERROR")) {
                            errorInstances = processInstance.getCount();
                        }
                        else {
                            log.error("Invalid State");
                        }
                    }

                    OMElement activeEle = factory.createOMElement("Active", null, instanceSummaryEle);
                    activeEle.setText(Integer.toString(activeInstances));
                    OMElement completedEle = factory.createOMElement("Completed", null, instanceSummaryEle);
                    completedEle.setText(Integer.toString(completedInstances));
                    OMElement failedEle = factory.createOMElement("Failed", null, instanceSummaryEle);
                    failedEle.setText(Integer.toString(failedInstances));
                    OMElement errorEle = factory.createOMElement("Error", null, instanceSummaryEle);
                    errorEle.setText(Integer.toString(errorInstances));
                    OMElement suspendedEle = factory.createOMElement("Suspended", null, instanceSummaryEle);
                    suspendedEle.setText(Integer.toString(suspendedInstances));
                    OMElement terminatedEle = factory.createOMElement("Terminated", null, instanceSummaryEle);
                    terminatedEle.setText(Integer.toString(terminatedInstances));

                    root.addChild(processEle);

                }
                OMElement numPagesEle = factory.createOMElement("Pages", null, root);
                numPagesEle.setText(Integer.toString(numberOfPages));
                OMElement pageNumEle = factory.createOMElement("PageNumber", null, root);
                pageNumEle.setText(Integer.toString(pageNumber));
                break;
            } else {
                pageNumber--;
                session.setAttribute("ppageNumber", pageNumber);
            }
        } else {
            OMElement numPagesEle = factory.createOMElement("Pages", null, root);
            numPagesEle.setText(Integer.toString(numberOfPages));
            break;
        }
    }
    request.setCharacterEncoding("UTF-8");
    // Set content to xml
    response.setContentType("text/xml; charset=UTF-8");

    PrintWriter pw = response.getWriter();
    pw.write(root.toString());
    pw.flush();
%>

                                            
