<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.wso2.carbon.bpel.ui.BPELPackageManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.DeleteStatus_type0" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.UndeployStatus_type0" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.RedeployStatus_type0" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<fmt:bundle basename="org.wso2.carbon.bpel.ui.i18n.Resources">
    <%
        response.setHeader("Cache-Control",
                "no-store, max-age=0, no-cache, must-revalidate");
        // Set IE extended HTTP/1.1 no-cache headers.
        response.addHeader("Cache-Control", "post-check=0, pre-check=0");
        // Set standard HTTP/1.0 no-cache header.
        response.setHeader("Pragma", "no-cache");

        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        Log log = LogFactory.getLog("deploy.packagesOnPages.ajaxprocessor");   //TODO

        BPELPackageManagementServiceClient client = null;
        DeleteStatus_type0 deleted = null;
        UndeployStatus_type0 undeployed = null;
        RedeployStatus_type0 redeployed = null;

        String operation = request.getParameter("operation");
        String packageName = request.getParameter("packageName");

        if (operation != null && packageName != null) {
            try {
                client = new BPELPackageManagementServiceClient(cookie, backendServerURL, configContext);
            } catch (Exception e) {
                log.error("BPEL Package Management Service Client Creation Failed.", e);
    %>
    <p id="ERRORDIALOG"><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message
            key="bpel.deletion_failed"/><br/><%=e.getMessage()%>
    </p>
    <%
        }

        if (client != null) {
            if (operation.toLowerCase().equals("delete")) {
                try {
                    deleted = client.deleteBPELPackage(packageName);
                } catch (Exception e) {
                    log.error("deleteBPELPackage operation failed", e);
    %>
    <p id="ERRORDIALOG"><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message
            key="bpel.deletion_failed"/><br/><%=e.getMessage()%>
    </p>
    <%
                }
                if (deleted != null) {
                    if (deleted.getValue().equals("FAILED")) {
    %>
    <p id="ERRORDIALOG"><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message key="bpel.deletion_failed"/></p>
    <%
                    } else if (deleted.getValue().equals("REGFAILED")) {
    %>
    <p id="ERRORDIALOG"><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message
            key="bpel.deletion_registry_failed"/></p>
    <%
                    } else {
    %>
    <p id="INFODIALOG"><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message key="deletion.successfull"/></p>
    <%
                    }
                }
            } else if (operation.toLowerCase().equals("undeploy")) {
                try {
                    undeployed = client.undeployBPELPackage(packageName);
                } catch (Exception e) {
                    log.error("undeployBPELPackage operation failed", e);
    %>
    <p id="ERRORDIALOG"><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message
            key="bpel.undeployment_failed"/><br/><%=e.getMessage()%>
    </p>
    <%
                }
                if (undeployed != null) {
                    if(!undeployed.getValue().equals("SUCCESS")) {
    %>
    <p id="ERRORDIALOG"><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message key="bpel.undeployment_failed"/></p>
    <%
                    } else {
    %>
    <p id="INFODIALOG"><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message key="undeployment.successfull"/></p>
    <%
                    }
                }
            } else if (operation.toLowerCase().equals("redeploy")) {
                try {
                    redeployed = client.redeployBPELPackage(packageName);
                } catch (Exception e) {
                    log.error("redeployBPELPackage operation failed", e);
    %>
    <p id="ERRORDIALOG"><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message
            key="bpel.redeployment_failed"/><br/><%=e.getMessage()%>
    </p>
    <%
                }
                if (redeployed != null) {
                    if (redeployed.getValue().equals("FAILED")) {
    %>
    <p><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message key="bpel.redeployment_failed"/></p>
    <%
                    } else if (redeployed.getValue().equals("EXISITS")) {
    %>
    <p><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message key="bpel.redeployment_exists"/></p>
    <%
                    } else if (redeployed.getValue().equals("NOTINREGISTRY")) {
    %>
    <p><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message key="bpel.redeployment_notinregistry"/></p>
    <%
                    } else {
    %>
    <p id="INFODIALOG"><fmt:message key="bpel.package"/> <%=packageName%> <fmt:message key="redeployment.successfull"/></p>
    <%
                    }
                }
            } else {
    %>
    <p id="ERRORDIALOG"><fmt:message key="unknown.bpel.package.management"/></p>
    <%
            }
        }
    } else {
     %>
    <p id="ERRORDIALOG"><fmt:message key="unknown.bpel.package.management"/></p>
    <%            
            }
    %>
</fmt:bundle>
