<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.bpel.ui.ProcessManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.ProcessInfoType" %>
<%@ page import="org.apache.http.HttpStatus" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<carbon:breadcrumb
        label="bpel.deployed_processes"
        resourceBundle="org.wso2.carbon.bpel.ui.i18n.Resources"
        topPage="true"
        request="<%=request%>"/>
<fmt:bundle basename="org.wso2.carbon.bpel.ui.i18n.Resources">
<%
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    ProcessManagementServiceClient client;

    String operation = request.getParameter("operation");
    if (operation != null) {

        if (operation.toLowerCase().equals("retire")) {
            String pid = request.getParameter("pid");

            if (pid != null && pid.length() > 0) {

                try {
                    client = new ProcessManagementServiceClient(cookie, backendServerURL, configContext);
                    ProcessInfoType processReturned = client.retireProcess(pid);
                    if (processReturned == null || !processReturned.getPid().trim().equals(pid.trim())) {
%>
<script type="text/javascript">
    jQuery(document).ready(function() {
        CARBON.showErrorDialog("<fmt:message key="error.retiring.process"/> <%=pid%>!");
    });
</script>
<%
    }
} catch (Exception e) {
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
            return;
        }
    }
} else if (operation.toLowerCase().equals("activate")) {
    String pid = request.getParameter("pid");

    if (pid != null && pid.length() > 0) {

        try {
            client = new ProcessManagementServiceClient(cookie, backendServerURL, configContext);
            ProcessInfoType processReturned = client.activateProcess(pid);
            if (processReturned == null || !processReturned.getPid().trim().equals(pid.trim())) {
%>
<script type="text/javascript">
    jQuery(document).ready(function() {
        CARBON.showErrorDialog("<fmt:message key="error.retiring.process"/> <%=pid%>!");
    });
</script>
<%
    }
} catch (Exception e) {
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
                    return;
                }
            }
        }
    }

    String filter = request.getParameter("filter");
    if (filter == null || filter.length() == 0) {
        if (session.getAttribute("pfilter") == null || ((String) session.getAttribute("pfilter")).length() == 0) {
            filter = "name}}* namespace=*";
            session.setAttribute("pfilter", "name}}* namespace=*");
        } else {
            filter = (String)session.getAttribute("pfilter");
        }
    } else {
        session.setAttribute("pfilter", filter);
    }
    String orderBy = request.getParameter("order");
    if (orderBy == null || orderBy.length() == 0) {
        if (session.getAttribute("porder") == null || ((String) session.getAttribute("porder")).length() == 0) {
            orderBy = "-deployed";
            session.setAttribute("porder", "-deployed");
        } else {
            orderBy = (String)session.getAttribute("porder");
        }
    } else {
        session.setAttribute("porder", orderBy);
    }
    String pageNumber = request.getParameter("page");
    if (pageNumber == null || pageNumber.length() == 0) {
        if(session.getAttribute("ppageNumber") == null){
            session.setAttribute("ppageNumber", 0);
            pageNumber = "0";
        }else{
            pageNumber  = (session.getAttribute("ppageNumber")).toString();
        }
    } else {
        int pageNum = Integer.parseInt(pageNumber);
        session.setAttribute("ppageNumber", pageNum);
    }
    String clearPage = request.getParameter("clearpage");
    if(clearPage!= null && clearPage.equals("yes")){
        pageNumber = "0";
        session.setAttribute("ppageNumber", 0);        
    }
%>
<div id="middle">
<script type="text/javascript" src="js/bpel-main.js"></script>
<script type="text/javascript" src="js/jquery.form.js"></script>
<script type="text/javascript">
    var currentPage = <%=pageNumber%>;
    var intObj ;
    BPEL.process.loadProcessList = function() {
        var listProcessURL = "list_processes-ajaxprocessor.jsp";

        jQuery.ajax({
            url: listProcessURL,
            dataType:'xml',
            type:'GET',
            error:function(xhr, textStatus, errorThrown) {
                if(textStatus != 'timeout'){
                    if(intObj){
                        clearInterval(intObj);
                    }
                }                  
            },
            success:BPEL.process.fillProcessList
        });
    };

    BPEL.process.fillProcessList = function(xml) {
        var j = 0;
        var scriptID = "instanceScript";
        var script = "";

        if (jQuery(xml).find('Pages').text() == "0" || $(xml).find('Pages').text() == undefined || $(xml).find('Pages').text() == null) {
             if($(xml).find('Pages').text() == undefined || $(xml).find('Pages').text() == null){
                jQuery("#process-list").html("<p><fmt:message key="error.occured.while.getting.process.list"/></p>");
             }else{
                jQuery("#process-list").html("<p><fmt:message key="there.are.no.processes.available"/>" + " " +
                        "<fmt:message key="please.reset.the.filter"/></p>");
             }                                                                                                           
            jQuery("#processListPagesUp").html("");
            jQuery("#processListPagesDown").html("");
            return true;
        } else {
            var pages = parseInt(jQuery(xml).find('Pages').text());
            var pagesHTML = "<table><tr>";
            currentPage = jQuery(xml).find('PageNumber').text();
            if (pages > 1) {
                if (currentPage > 0) {
                    pagesHTML += "<td><strong><a href='process_list.jsp?page=" + (parseInt(currentPage) - 1) +
                                 "'>&lt;&nbsp;prev&nbsp;&nbsp;</a></strong></td>";
                }
                for (var i = 0; i < pages; i++) {
                    if (i == currentPage) {
                        pagesHTML += "<td><strong>" + (i + 1) + "&nbsp;&nbsp;</strong></td>";
                    } else {
                        pagesHTML += "<td><strong><a href='process_list.jsp?page=" + i + "'>" + (i + 1) + " &nbsp;&nbsp;</a></strong></td>";
                    }
                }
                if (currentPage < (pages - 1)) {
                    pagesHTML += "<td><strong><a href='process_list.jsp?page=" + (parseInt(currentPage) + 1) +
                                 "'>&lt;&nbsp;next&nbsp;&gt;&nbsp;</a></strong></td>";
                }
            }
            pagesHTML += "</tr></table>";

            jQuery("#processListPagesUp").html(pagesHTML);
            jQuery("#processListPagesDown").html(pagesHTML);
        }


        var tableHTML = "<table id='processListTable' class='styledLeft' width='100%'><thead><th><fmt:message key="processid"/></th><th><fmt:message key="version"/></th><th><fmt:message key="status"/></th><th><fmt:message key="deployed.date"/></th>" +
                        "<th><fmt:message key="manage"/><th><fmt:message key="tryit"/></th></thead><tbody>";
        jQuery(xml).find('Process').each(function(index) {
            var pid = jQuery(this).find('Pid').text();
            var status = jQuery(this).find('Status').text();
            var version = jQuery(this).find('Version').text();
            var deployed = jQuery(this).find('Deployed').text();
            var processFunc = "process" + j;
            var oldVersion = jQuery(this).find('OlderVersion').text();

            tableHTML += "<tr><td><a href='process_view.jsp?pid=" + pid + "'>" + pid +
                         "</a></td><td style='text-align:center;'>" + version + "</td><td style='text-align:center;'>"
                    + status + "<td style='text-align:center;'>" + deployed + "</td><td style='text-align:center;'>";
            if (status.toUpperCase() == "ACTIVE") {
                script += "function retireProcess" + processFunc + "(){function retireYes(){" +
                          "window.location.href='process_list.jsp?operation=retire&pid=" + pid + "';}" +
                          "CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.retire.process"/> " + pid +
                          "?', retireYes, null);return false;}";

                tableHTML += "<a href='#' class='icon-link' style='background-image:url(images/deactivate.gif);'  onclick='retireProcess"
                        + processFunc + "()'><fmt:message key="retire"/></a></td><td>";
                jQuery(this).find('EndPointAddress').each(function(index) {
                    var endPointAddress = jQuery(this).text();
                    var tempArray = endPointAddress.split('/');
                    var service = tempArray[tempArray.length - 1];
                    tableHTML += "<div style='heght: 25px;'><a target='_blank' href='" + endPointAddress +
                             "?tryit' class='icon-link' style='background-image:url(images/tryit.gif);'><fmt:message key="try"/> "
                            + service + " </a></div><div style='clear:both;'></div>";
                });

                tableHTML += "</td>";
            } else if (oldVersion == "0"){
                script += "function activateProcess" + processFunc + "(){function activateYes(){" +
                          "window.location.href='process_list.jsp?operation=activate&pid=" + pid + "';}" +
                          "CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.activate.process"/> " +
                          pid + "?', activateYes, null);return false;}";

                tableHTML += "<a href='#'  class='icon-link' style='background-image:url(images/activate.gif);'  onclick='activateProcess"
                        + processFunc + "()'><fmt:message key="activate"/></a></td><td></td>";
            } else {
                tableHTML += "</td><td></td>";
            }
            tableHTML += "</tr>";
            j++;
        });
        tableHTML += "</tbody></table>";

        jQuery("#process-list").html(tableHTML);
        alternateTableRows('processListTable', 'tableEvenRow', 'tableOddRow');

        var headID = document.getElementsByTagName("head")[0];
        var newScript = document.createElement('script');
        newScript.type = 'text/javascript';
        newScript.setAttribute('id', scriptID);
        var oldScriptEle = document.getElementById(scriptID);
        if (null == newScript.canHaveChildren || newScript.canHaveChildren) {
            newScript.appendChild(document.createTextNode(script));
        } else {
            newScript.text = script;
        }

        if (oldScriptEle) {
            headID.replaceChild(newScript, oldScriptEle);
        } else {
            headID.appendChild(newScript);
        }
    };

    BPEL.process.initForm = function() {
        jQuery('#date').datepicker({ showOn: 'button', buttonImage: 'images/calendar.gif', buttonImageOnly: true,
            buttonText: 'Choose Date', showAnim: 'slideDown', onSelect: function(dateText, inst) {
                var dateOption = jQuery("#processFilterForm :radio[@name='dateopt']").fieldValue()[0];
                if (!dateOption) {
                     $("#processFilterForm :radio[@name='dateopt']").val(["onb"]);
                }
            }
        });

        BPEL.process.fillFilter();
        
        jQuery('#processFilterForm').submit(function() {
            var name;
            var namespace;
            var dateOpt;
            var date;
            var order;
            var orderBy;
            var filter = "";
            var processOrder = "";
            var d;

            namespace = jQuery.trim(jQuery("#processFilterForm :text[@name='namespace']").fieldValue()[0]);
            name = jQuery.trim(jQuery("#processFilterForm :text[@name='name']").fieldValue()[0]);
            date = jQuery("#processFilterForm :text[@name='date']").fieldValue()[0];

            if (BPEL.process.validateURI(namespace)) {
                if (BPEL.process.validateURI(name)) {
                    if (BPEL.process.validateDate(date)) {
                        dateOpt = jQuery("#processFilterForm :radio[@name='dateopt']").fieldValue()[0];
                        orderBy = $("#orderbytype")[0].value;
                        order = $("#processFilterForm :radio[@name='asdec']").fieldValue()[0];

                        if (orderBy && (typeof orderBy).toLowerCase() == 'string') {
                            if (order && (typeof order).toLowerCase() == 'string' && order.toLowerCase() == 'ascending') {
                                processOrder = "+" + orderBy.toLowerCase();
                            } else if (order && (typeof order).toLowerCase() == 'string' && order.toLowerCase() == 'descending') {
                                processOrder = "-" + orderBy.toLowerCase();
                            }
                        } else {
                            processOrder = "+name";
                        }

                        if (name && (typeof name).toLowerCase() == 'string') {
                            /*                 I think we dont need to support {{ type filters
                             if (name.indexOf('{') == 0 || name.indexOf('}') == 0) {
                             filter += "name" + name + " ";
                             } else {
                             filter += "name=" + name + " ";
                             }*/
                            filter += "name=" + name + " ";
                        }

                        if (namespace && (typeof namespace).toLowerCase() == 'string') {
                            filter += "namespace=" + namespace + " ";
                        }
                        if (date && (typeof date).toLowerCase() == 'string') {
                            d = date.split("/");
                            if (!dateOpt) {
                                filter += "deployed=" + d[2] + "-" + d[0] + "-" + d[1] + " ";
                            } else if (dateOpt.toLowerCase() == "onb") {
                                filter += "deployed<=" + d[2] + "-" + d[0] + "-" + d[1] + " ";
                            } else if (dateOpt.toLowerCase() == "ona") {
                                filter += "deployed>=" + d[2] + "-" + d[0] + "-" + d[1] + " ";
                            }
                        }

                        if (!name && !namespace && !dateOpt && !date) {
                            filter = "name}}* namespace=*";
                        }

                        window.location.href = "process_list.jsp?filter=" + encodeURIComponent(filter) + "&order=" +
                                               encodeURIComponent(processOrder) + "&clearpage=" + encodeURIComponent("yes");
                    } else {
                         CARBON.showErrorDialog("<p><fmt:message key="enter.valide.date"/></p>");
                    }
                } else {
                     CARBON.showErrorDialog("<p><fmt:message key="enter.valide.name"/></p>");
                }
            } else {
                CARBON.showErrorDialog("<p><fmt:message key="enter.valide.namespace"/></p>");
            }

            return false;
        });

        jQuery('#resetProcessFilter').click(function() {
            window.location.href = "process_list.jsp?filter=" + encodeURIComponent("name}}* namespace=*") + "&order=" +
                                   encodeURIComponent("-deployed");
            return false;
        });
    };

    BPEL.process.addSliding = function() {
        jQuery("#filterToggleBtn").click(function() {
            jQuery("#formsetProcessList").slideToggle("normal");
            jQuery(this).toggleClass("active");
            return false;
        });
    };

    BPEL.process.fillFilter = function() {
        var status = '<%=filter%>';
        var orderby = '<%=orderBy%>';
        var name;
        var namespace;
        var deployed;
        var dateOpt;
        var params;
        var order;
        
        params = status.split(" ");
        for(var i = 0; i < params.length; i++)
        {
            var param = params[i].split("=");
            switch(param[0])
            {
            case "name":
              name = param[1];
              break;
            case "namespace":
              namespace = param[1];
              break;
            case "deployed>":
              deployed = param[1];
              dateOpt =  "ona";
              break;
            case "deployed<":
              deployed = param[1];
              dateOpt =  "onb";
              break;
            case "deployed":
              deployed = param[1];
              dateOpt = false;
              break;
      /*      default:
              param = params[i].split("deployed<");
              if (param.length == 2 && param[0] == "") {
                  deployed = param[1];
                  dateOpt = "onb";
              }*/
            }
        }

        if (deployed && (typeof deployed).toLowerCase() == 'string' && deployed.indexOf("-") != -1) {
              var d = deployed.split("-");
                    deployed = d[1] + "/" + d[2] + "/" + d[0];
        }

        if (orderby.indexOf("-") == 0) {
            order = "Descending";
            orderby = orderby.substring(1);
        } else if (orderby.length != 0) {
            order = "Ascending";
            orderby = orderby.substring(1);
        } else {
            order = "Descending";
            orderby = "deployed";
        }
        
        $("#processFilterForm :text[@name='name']").val(name);
        $("#processFilterForm :text[@name='order']").val(orderby);
        $("#processFilterForm :radio[@name='dateopt']").val([dateOpt]);
        $("#processFilterForm :text[@name='date']").val(deployed);
        if (namespace == '' || namespace == undefined) {
            namespace = '*';
        }
        $("#processFilterForm :text[@name='namespace']").val(namespace);
        $("#processFilterForm :radio[@name='asdec']").val([order]);
        $("#orderbytype").val(orderby);

        if (status == "name}}* namespace=*") {
            $("#resetProcessFilter").css("display", "none");
        }
    };

    BPEL.process.loading = function() {
    $("#loading").bind("ajaxStart", function() {
        var tOffset = $("#process-list").offset();
        var tWidth = $("#process-list").width();
        $("#load-image").attr("src", "images/loader.gif");
        var iWidth = $("#load-image").width();
        var loadLeft = parseInt(tOffset.left) + (parseInt(tWidth) - parseInt(iWidth))/2;
        $("#loading ").css("top", tOffset.top).css("left", loadLeft);
        $(this).css("display", "block");
     }).bind("ajaxStop", function() {
        $(this).css("display", "none");
     });
};

     BPEL.process.validateURI = function(namespace) {
         if (namespace == '') {
             namespace = '*';
         }
         //the following characters should be checked here. Otherwise if these characters in the name/namespace ODE
         // filter does not split filterkey, op, value correctly
         return (namespace.indexOf("'") < 0 && namespace.indexOf("=") < 0 && namespace.indexOf("<") < 0 &&
                 namespace.indexOf(">") < 0);
            
         /*if (namespace == '*') {
             return true;
         } */
         //uri validation is removed in-oder to add wildcard support
         /*var matches = namespace.match(/^(https?|ftp|[a-z]+):(\/\/)?(((([a-z]|\d|-|\.|:|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|:|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))+(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|:|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))[\.:]?)(:\d*)?)(\/((([a-z]|\d|-|\.|:|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|:|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|:|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|:|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i);
          if (matches) {
          return true;
          }
          return false;*/
     };

    BPEL.process.validateDate = function(datestr) {
        if (datestr == '')
            return true;
        
        var matches = datestr.match(/^((([0][13578]|[1][02])\/([012][\d]|[3][01]))|(([0][469]|[1][1])\/([012][\d]|[3][0]))|([0][2]\/([01][\d]|[2][0123456789])))\/[\d]{4}$/);

        if (matches) {
            return true;
        }
        return false;
    };

    jQuery(document).ready(function() {
        BPEL.process.loading();
        BPEL.process.initForm();
        BPEL.process.loadProcessList();
        BPEL.process.addSliding();
        intObj = setInterval("BPEL.process.loadProcessList()", 10000);
    });
</script>
<style type="text/css">
    table.styledLeft thead th {
        padding-bottom: 0;
        padding-top: 0;
        padding-right: 0;
    }

    #formsetProcessList {
        height: 180px;
        display: none;
        padding-top: 5px;
        padding-bottom: 5px;
        padding-left: 0px;
        padding-right: 0px;
    }

    #loading {
        display: none;
        position: absolute;
        z-index: 100;
    }

    .slide-btn {
        background-image: url( images/show.gif );
        background-position: left top;
        background-repeat: no-repeat;
        float: left;
        height: 17px;
        line-height: 17px;
        margin-bottom: 3px;
        margin-left: 0px;
        margin-top: 5px;
        padding-left: 20px;
        position: relative;
        white-space: nowrap;
    }

    .active {
        background-image: url( images/hide.gif );
    }

    .ui-datepicker-trigger {
        cursor: pointer;
    }

</style>


<div id="process-list-main">
    <h2><fmt:message key="bpel.deployed_processes"/></h2>

    <div id="workArea">
        <table>
            <tbody>
            <tr>
                <td><a href="#" id="filterToggleBtn" class="slide-btn"><fmt:message key="filter.process.list"/> </a>
                </td>
                <td><a href="#" id="resetProcessFilter" class="icon-link" style="background-image:url(images/reset.gif)"><fmt:message key="reset.filter"/></a></td>
            </tr>
            </tbody>
        </table>
        <div id="formsetProcessList">
            <form class="process_filter" action="GET" id="processFilterForm" target="_self">

                <table class="styledLeft" width="100%">
                    <thead>
                    <tr>
                        <th><fmt:message
                                key="narrow.down.the.list.of.processes.by.applying.following.selection.criteria"/>
                        </th>
                    </tr>
                    </thead>
                    <tbody id="filterBody">
                    <tr>
                        <td>
                            <table class="normal">
                                <tr>
                                    <td><fmt:message key="name"/></td>
                                    <td style="text-align:right;">
                                        <input type="text" size="45" name="name">
                                    </td>
                                </tr>
                                <tr>
                                    <td><fmt:message key="namespace"/></td>
                                    <td style="text-align:right;">
                                        <input type="text" size="45" id="namespace" name="namespace">
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <fmt:message key="deployed.between"/>
                                    </td>
                                    <td style="text-align:right;">
                                        <input type="radio" name="dateopt" value="onb"> <fmt:message key="on.or.before"/>
                                        <input type="radio" name="dateopt" value="ona"> <fmt:message key="on.or.after"/>
                                        <input type="text" id="date" size="17" name="date">
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <fmt:message key="order.by"/>
                                    </td>
                                    <td>
                                        <input type="radio" name="asdec" value="Ascending" checked><fmt:message
                                            key="ascending"/>
                                        <input type="radio" name="asdec" value="Descending" checked><fmt:message
                                            key="descending"/>
                                        <select id="orderbytype" name="orderby">
                                            <option value="name"><fmt:message key="process.name"/></option>
                                            <option value="namespace"><fmt:message key="process.namespace"/></option>
                                            <option value="version"><fmt:message key="version"/></option>
                                            <option value="status"><fmt:message key="status"/></option>
                                            <option value="deployed"><fmt:message key="deployed.date"/></option>
                                        </select>
                                    </td>
                                    <!--td style="text-align:right;">
                                        <input type="text" size="45" id="orderkeys" name="order">
                                    </td-->
                                </tr>

                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <input class="button" type="submit" value="Filter">
                            <input class="button" type="reset" value="Clear">
                        </td>
                    </tr>
                    </tbody>

                </table>
            </form>
        </div>
        <p>&nbsp;</p>

        <div id="processListPagesUp"></div>
        <p>&nbsp;</p>

        <div id="process-list">

        </div>

        <div id="loading" >
             <img id="load-image"/>
        </div>
        
        <p>&nbsp;</p>

        <div id="processListPagesDown"></div>
    </div>
</div>
</div>
</fmt:bundle>
